/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.7 */

#ifndef PB_STOREFORWARD_PB_H_INCLUDED
#define PB_STOREFORWARD_PB_H_INCLUDED
#include <pb.h>

#if PB_PROTO_HEADER_VERSION != 40
#error Regenerate this file with the current version of nanopb generator.
#endif

/* Enum definitions */
/* 001 - 063 = From Router
 064 - 127 = From Client */
typedef enum _StoreAndForward_RequestResponse {
    /* Unset/unused */
    StoreAndForward_RequestResponse_UNSET = 0,
    /* Router is an in error state. */
    StoreAndForward_RequestResponse_ROUTER_ERROR = 1,
    /* Router heartbeat */
    StoreAndForward_RequestResponse_ROUTER_HEARTBEAT = 2,
    /* Router has requested the client respond. This can work as a
 "are you there" message. */
    StoreAndForward_RequestResponse_ROUTER_PING = 3,
    /* The response to a "Ping" */
    StoreAndForward_RequestResponse_ROUTER_PONG = 4,
    /* Router is currently busy. Please try again later. */
    StoreAndForward_RequestResponse_ROUTER_BUSY = 5,
    /* Router is responding to a request for history. */
    StoreAndForward_RequestResponse_ROUTER_HISTORY = 6,
    /* Router is responding to a request for stats. */
    StoreAndForward_RequestResponse_ROUTER_STATS = 7,
    /* Client is an in error state. */
    StoreAndForward_RequestResponse_CLIENT_ERROR = 64,
    /* Client has requested a replay from the router. */
    StoreAndForward_RequestResponse_CLIENT_HISTORY = 65,
    /* Client has requested stats from the router. */
    StoreAndForward_RequestResponse_CLIENT_STATS = 66,
    /* Client has requested the router respond. This can work as a
 "are you there" message. */
    StoreAndForward_RequestResponse_CLIENT_PING = 67,
    /* The response to a "Ping" */
    StoreAndForward_RequestResponse_CLIENT_PONG = 68,
    /* Client has requested that the router abort processing the client's request */
    StoreAndForward_RequestResponse_CLIENT_ABORT = 106
} StoreAndForward_RequestResponse;

/* Struct definitions */
/* TODO: REPLACE */
typedef struct _StoreAndForward_Statistics {
    /* Number of messages we have ever seen */
    uint32_t messages_total;
    /* Number of messages we have currently saved our history. */
    uint32_t messages_saved;
    /* Maximum number of messages we will save */
    uint32_t messages_max;
    /* Router uptime in seconds */
    uint32_t up_time;
    /* Number of times any client sent a request to the S&F. */
    uint32_t requests;
    /* Number of times the history was requested. */
    uint32_t requests_history;
    /* Is the heartbeat enabled on the server? */
    bool heartbeat;
    /* Is the heartbeat enabled on the server? */
    uint32_t return_max;
    /* Is the heartbeat enabled on the server? */
    uint32_t return_window;
} StoreAndForward_Statistics;

/* TODO: REPLACE */
typedef struct _StoreAndForward_History {
    /* Number of that will be sent to the client */
    uint32_t history_messages;
    /* The window of messages that was used to filter the history client requested */
    uint32_t window;
    /* The window of messages that was used to filter the history client requested */
    uint32_t last_request;
} StoreAndForward_History;

/* TODO: REPLACE */
typedef struct _StoreAndForward_Heartbeat {
    /* Number of that will be sent to the client */
    uint32_t period;
    /* If set, this is not the primary Store & Forward router on the mesh */
    uint32_t secondary;
} StoreAndForward_Heartbeat;

/* TODO: REPLACE */
typedef struct _StoreAndForward {
    /* TODO: REPLACE */
    StoreAndForward_RequestResponse rr;
    pb_size_t which_variant;
    union {
        /* TODO: REPLACE */
        StoreAndForward_Statistics stats;
        /* TODO: REPLACE */
        StoreAndForward_History history;
        /* TODO: REPLACE */
        StoreAndForward_Heartbeat heartbeat;
        /* Empty Payload */
        bool empty;
    } variant;
} StoreAndForward;


#ifdef __cplusplus
extern "C" {
#endif

/* Helper constants for enums */
#define _StoreAndForward_RequestResponse_MIN StoreAndForward_RequestResponse_UNSET
#define _StoreAndForward_RequestResponse_MAX StoreAndForward_RequestResponse_CLIENT_ABORT
#define _StoreAndForward_RequestResponse_ARRAYSIZE ((StoreAndForward_RequestResponse)(StoreAndForward_RequestResponse_CLIENT_ABORT+1))

#define StoreAndForward_rr_ENUMTYPE StoreAndForward_RequestResponse





/* Initializer values for message structs */
#define StoreAndForward_init_default             {_StoreAndForward_RequestResponse_MIN, 0, {StoreAndForward_Statistics_init_default}}
#define StoreAndForward_Statistics_init_default  {0, 0, 0, 0, 0, 0, 0, 0, 0}
#define StoreAndForward_History_init_default     {0, 0, 0}
#define StoreAndForward_Heartbeat_init_default   {0, 0}
#define StoreAndForward_init_zero                {_StoreAndForward_RequestResponse_MIN, 0, {StoreAndForward_Statistics_init_zero}}
#define StoreAndForward_Statistics_init_zero     {0, 0, 0, 0, 0, 0, 0, 0, 0}
#define StoreAndForward_History_init_zero        {0, 0, 0}
#define StoreAndForward_Heartbeat_init_zero      {0, 0}

/* Field tags (for use in manual encoding/decoding) */
#define StoreAndForward_Statistics_messages_total_tag 1
#define StoreAndForward_Statistics_messages_saved_tag 2
#define StoreAndForward_Statistics_messages_max_tag 3
#define StoreAndForward_Statistics_up_time_tag   4
#define StoreAndForward_Statistics_requests_tag  5
#define StoreAndForward_Statistics_requests_history_tag 6
#define StoreAndForward_Statistics_heartbeat_tag 7
#define StoreAndForward_Statistics_return_max_tag 8
#define StoreAndForward_Statistics_return_window_tag 9
#define StoreAndForward_History_history_messages_tag 1
#define StoreAndForward_History_window_tag       2
#define StoreAndForward_History_last_request_tag 3
#define StoreAndForward_Heartbeat_period_tag     1
#define StoreAndForward_Heartbeat_secondary_tag  2
#define StoreAndForward_rr_tag                   1
#define StoreAndForward_stats_tag                2
#define StoreAndForward_history_tag              3
#define StoreAndForward_heartbeat_tag            4
#define StoreAndForward_empty_tag                5

/* Struct field encoding specification for nanopb */
#define StoreAndForward_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    rr,                1) \
X(a, STATIC,   ONEOF,    MESSAGE,  (variant,stats,variant.stats),   2) \
X(a, STATIC,   ONEOF,    MESSAGE,  (variant,history,variant.history),   3) \
X(a, STATIC,   ONEOF,    MESSAGE,  (variant,heartbeat,variant.heartbeat),   4) \
X(a, STATIC,   ONEOF,    BOOL,     (variant,empty,variant.empty),   5)
#define StoreAndForward_CALLBACK NULL
#define StoreAndForward_DEFAULT NULL
#define StoreAndForward_variant_stats_MSGTYPE StoreAndForward_Statistics
#define StoreAndForward_variant_history_MSGTYPE StoreAndForward_History
#define StoreAndForward_variant_heartbeat_MSGTYPE StoreAndForward_Heartbeat

#define StoreAndForward_Statistics_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   messages_total,    1) \
X(a, STATIC,   SINGULAR, UINT32,   messages_saved,    2) \
X(a, STATIC,   SINGULAR, UINT32,   messages_max,      3) \
X(a, STATIC,   SINGULAR, UINT32,   up_time,           4) \
X(a, STATIC,   SINGULAR, UINT32,   requests,          5) \
X(a, STATIC,   SINGULAR, UINT32,   requests_history,   6) \
X(a, STATIC,   SINGULAR, BOOL,     heartbeat,         7) \
X(a, STATIC,   SINGULAR, UINT32,   return_max,        8) \
X(a, STATIC,   SINGULAR, UINT32,   return_window,     9)
#define StoreAndForward_Statistics_CALLBACK NULL
#define StoreAndForward_Statistics_DEFAULT NULL

#define StoreAndForward_History_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   history_messages,   1) \
X(a, STATIC,   SINGULAR, UINT32,   window,            2) \
X(a, STATIC,   SINGULAR, UINT32,   last_request,      3)
#define StoreAndForward_History_CALLBACK NULL
#define StoreAndForward_History_DEFAULT NULL

#define StoreAndForward_Heartbeat_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   period,            1) \
X(a, STATIC,   SINGULAR, UINT32,   secondary,         2)
#define StoreAndForward_Heartbeat_CALLBACK NULL
#define StoreAndForward_Heartbeat_DEFAULT NULL

extern const pb_msgdesc_t StoreAndForward_msg;
extern const pb_msgdesc_t StoreAndForward_Statistics_msg;
extern const pb_msgdesc_t StoreAndForward_History_msg;
extern const pb_msgdesc_t StoreAndForward_Heartbeat_msg;

/* Defines for backwards compatibility with code written before nanopb-0.4.0 */
#define StoreAndForward_fields &StoreAndForward_msg
#define StoreAndForward_Statistics_fields &StoreAndForward_Statistics_msg
#define StoreAndForward_History_fields &StoreAndForward_History_msg
#define StoreAndForward_Heartbeat_fields &StoreAndForward_Heartbeat_msg

/* Maximum encoded size of messages (where known) */
#define StoreAndForward_Heartbeat_size           12
#define StoreAndForward_History_size             18
#define StoreAndForward_Statistics_size          50
#define StoreAndForward_size                     54

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
